
    const peg = require('pegjs');
    const rules = [


      'START = (CODE_DIRECTIVE / DIRECTIVE / LITERAL / MINIFIED_LITERAL / BLANK / TEXT)*',


      `
      BLANK = [ ]* EOL {
        return {
          type: 'blank',
          text: '',
          lineNumber: location().start.line,
        }
      }

      EOL = '\\r\\n' / '\\n' / '\\r'
      `,


      `
      CODE_DIRECTIVE = indent:[ ]* tag:CODE_DIRECTIVE_TAG BLANK DIRECTIVE_OPTION* {
        return {
          type: 'code',
          language: tag.language,
          indent: indent.length,
        }
      }

      CODE_DIRECTIVE_TAG = '.. ' CODE_DIRECTIVE_NAME ':: ' language:CODE_DIRECTIVE_LANGUAGE {
        return {
          language: language,
        }
      }

      CODE_DIRECTIVE_NAME = 'code-block'i / 'sourcecode'i / 'code'i
      CODE_DIRECTIVE_LANGUAGE = 'javascript'i / 'json'i
      `,


      `
      DIRECTIVE_OPTION = indent:[ ]* ':' [A-Za-z-]+ ':' (!EOL .)* BLANK
      `,


      `
      DIRECTIVE = indent:[ ]* '.. ' [A-Za-z-]+ '::' BLANK {
        return {
          type: 'directive',
          indent: indent.length,
        }
      }
      `,


      `
      LITERAL = indent:[ ]* '::' BLANK {
        return {
          type: 'javascript',
          indent: indent.length,
        }
      }
      `,


      `
      MINIFIED_LITERAL = indent:[ ]* (!EOL !('::' BLANK) .)* '::' BLANK {
        return {
          type: 'javascript',
          indent: indent.length,
        }
      }
      `,


      `
      TEXT = indent:[ ]* characters:(!EOL character:. { return character })+ EOL? {
        return {
          type: 'text',
          indent: indent.length,
          text: indent.join('') + characters.join(''),
          lineNumber: location().start.line,
        }
      }
      `,
    ];

    const parser = peg.generate(rules.join(''));



    const detab = require('detab');

    module.exports = function parse(content) {


      const detabbed = detab(content, 8);


      return parser.parse(detabbed);
    };

