
    const literacy = require('./index.js');

    function loadJsRstFile(module, filename) {
      const javaScript = literacy.fromFile(filename).content;
      module._compile(javaScript, filename);
    }


    if (require.extensions) {
      require.extensions['.js.rst'] = loadJsRstFile;
    }


    function loadJsonRstFile(module, filename) {
      const json = literacy.fromFile(filename).content;
      module.exports = JSON.parse(json);
    }

    if (require.extensions) {
      require.extensions['.json.rst'] = loadJsonRstFile;
    }


    const path = require('path');
    const Module = require('module');

    function findExtension(filename) {
      const extensions = path.basename(filename).split('.');


      if (extensions[0] === '') {
        extensions.shift();
      }


      while (extensions.shift()) {
        const current = `.${ extensions.join('.') }`;

        if (Module._extensions[current]) {
          return current;
        }
      }


      return '.js';
    }


    const assert = require('assert').ok;
    const debug = Module._debug;

    if (require.extensions) {
      Module.prototype.load = function load(filename) {
        debug('load %j for module %j', filename, this.id);

        assert(!this.loaded);
        this.filename = filename;
        this.paths = Module._nodeModulePaths(path.dirname(filename));

        const extension = findExtension(filename);
        Module._extensions[extension](this, filename);

        this.loaded = true;
      };
    }

