
    const fs = require('fs-extra');
    const dir = require('node-dir');

    module.exports.recursivelyEnumerate = function recursivelyEnumerate(filename) {
      let expanded = [ filename ];
      if (fs.statSync(filename).isDirectory()) {
        expanded = dir.files(filename, { sync: true });
      }

      return expanded;
    };



    const glob = require('glob');
    const uniq = require('lodash/uniq');

    module.exports.expand = function expand(paths) {
      const output = [];

      paths.forEach(path => {
        const expanded = glob.sync(path);


        if (expanded.length === 0) {
          output.push(path);
        } else {
          output.push(...expanded);
        }
      });


      return uniq(output);
    };

